## libarcus 3.1.0

=== CMakeLists.txt ===
project(arcus)
cmake_minimum_required(VERSION 2.8.12)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

option(BUILD_PYTHON "Build " ON)
option(BUILD_EXAMPLES "Build the example programs" ON)
option(BUILD_STATIC "Build as a static library" OFF)

option(MSVC_STATIC_RUNTIME "Link the MSVC runtime statically" OFF)

# We want to have access to protobuf_generate_cpp and other FindProtobuf features.
# However, if ProtobufConfig is used instead, there is a CMake option that controls
# this, which defaults to OFF. We need to force this option to ON instead.
set(protobuf_MODULE_COMPATIBLE ON CACHE "" INTERNAL FORCE)
find_package(Protobuf 3.0.0 REQUIRED)

set(CMAKE_POSITION_INDEPENDENT_CODE ON) #Required if a patch to libArcus needs to be made via templates.

if(BUILD_PYTHON)
    set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
    find_package(SIP REQUIRED)
    if(NOT DEFINED LIB_SUFFIX)
        set(LIB_SUFFIX "")
    endif()
    if(EXISTS /etc/debian_version)
        # Running on a debian-based system, which requires special handling for python modules.
        set(PYTHON_SITE_PACKAGES_DIR lib${LIB_SUFFIX}/python3/dist-packages CACHE STRING "Directory to install Python bindings to")
    else()
        set(PYTHON_SITE_PACKAGES_DIR lib${LIB_SUFFIX}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages CACHE STRING "Directory to install Python bindings to")
    endif()
    include_directories(python/ src/ ${SIP_INCLUDE_DIR} ${PYTHON_INCLUDE_DIR})
endif()

if(NOT ${CMAKE_VERSION} VERSION_LESS 3.1)
    set(CMAKE_CXX_STANDARD 11)
else()
    set(CMAKE_CXX_FLAGS "-std=c++11")
endif()

if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

set(arcus_SRCS
    src/Socket.cpp
    src/SocketListener.cpp
    src/MessageTypeStore.cpp
    src/PlatformSocket.cpp
    src/Error.cpp
)

set(arcus_HDRS
    src/Socket.h
    src/SocketListener.h
    src/Types.h
    src/ArcusExport.h
    src/MessageTypeStore.h
    src/Error.h
)

set(ARCUS_VERSION 1.1.0)
set(ARCUS_SOVERSION 3)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

if(BUILD_STATIC)
    add_library(Arcus STATIC ${arcus_SRCS})
    if(NOT WIN32 OR CMAKE_COMPILER_IS_GNUCXX)
        target_link_libraries(Arcus PRIVATE pthread)
        set_target_properties(Arcus PROPERTIES COMPILE_FLAGS -fPIC)
    endif()
else()
    add_library(Arcus SHARED ${arcus_SRCS})
endif()

if(MSVC_STATIC_RUNTIME)
    foreach(flag_var
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
    if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
    endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
endif()

if(BUILD_PYTHON)
    set(SIP_EXTRA_FILES_DEPEND python/SocketListener.sip python/Types.sip python/PythonMessage.sip python/Error.sip)
    set(SIP_EXTRA_SOURCE_FILES python/PythonMessage.cpp)
    set(SIP_EXTRA_OPTIONS -g) # -g means always release the GIL before calling C++ methods.
    add_sip_python_module(Arcus python/Socket.sip Arcus)
endif()

target_include_directories(Arcus PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${PROTOBUF_INCLUDE_DIR}
)
target_link_libraries(Arcus PUBLIC ${PROTOBUF_LIBRARIES})

if(WIN32)
    add_definitions(-D_WIN32_WINNT=0x0600) # Declare we require Vista or higher, this allows us to use IPv6 functions.
    target_link_libraries(Arcus PUBLIC Ws2_32)
endif()

if(${CMAKE_BUILD_TYPE})
    if(${CMAKE_BUILD_TYPE} STREQUAL "Debug" OR ${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo")
        add_definitions(-DARCUS_DEBUG)
    endif()
endif()

set_target_properties(Arcus PROPERTIES
    FRAMEWORK FALSE
    VERSION ${ARCUS_VERSION}
    SOVERSION ${ARCUS_SOVERSION}
    PUBLIC_HEADER "${arcus_HDRS}"
    DEFINE_SYMBOL MAKE_ARCUS_LIB
)

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

install(TARGETS Arcus
    EXPORT Arcus-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Arcus
)

install(EXPORT Arcus-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Arcus
)

configure_package_config_file(ArcusConfig.cmake.in ${CMAKE_BINARY_DIR}/ArcusConfig.cmake INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Arcus)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/ArcusConfigVersion.cmake VERSION ${ARCUS_VERSION} COMPATIBILITY SameMajorVersion)

install(FILES
    ${CMAKE_BINARY_DIR}/ArcusConfig.cmake
    ${CMAKE_BINARY_DIR}/ArcusConfigVersion.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Arcus
)

include(CPackConfig.cmake)

=== debian/changelog ===
libarcus (3.1.0-1ubuntu1) bionic; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Update libarcus3.symbols for -O3 on ppc64el 

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 28 Jan 2018 20:51:18 +0000

libarcus (3.1.0-1) unstable; urgency=medium

  * New upstream release 3.1.0

 -- Gregor Riepl <onitake@gmail.com>  Tue, 16 Jan 2018 23:50:49 +0100

libarcus (3.0.3-4) unstable; urgency=medium

  * Added more missing symbols for arch:armel

 -- Gregor Riepl <onitake@gmail.com>  Thu, 30 Nov 2017 08:12:42 +0100

libarcus (3.0.3-3) unstable; urgency=medium

  * Added missing symbols for arch:armel
    Closes: #882495

 -- Gregor Riepl <onitake@gmail.com>  Wed, 29 Nov 2017 18:52:13 +0100

libarcus (3.0.3-2ubuntu1) bionic; urgency=medium

  * Update libarcus3.symbols for -O3 on ppc64el 

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 29 Nov 2017 19:30:33 +0000

libarcus (3.0.3-2) unstable; urgency=medium

  * Updated symbols file to make the build succeed on other
    architectures than amd64 (Closes: #882495)

 -- Gregor Riepl <onitake@gmail.com>  Fri, 24 Nov 2017 20:19:48 +0100

libarcus (3.0.3-1) unstable; urgency=medium

  [ Gregor Riepl ]
  * New upstream release 3.0.3.
  * Upstream license change to LGPL-3+.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 30 Oct 2017 09:15:52 +0000

libarcus (2.5.0-1) UNRELEASED; urgency=medium

  * Initial Debian release. Closes: #706656

 -- Gregor Riepl <onitake@gmail.com>  Wed, 26 Apr 2017 08:17:37 +0200

=== debian/control ===
Source: libarcus
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders: Gregor Riepl <onitake@gmail.com>
Build-Depends: debhelper (>= 10), cmake (>=2.8.12), dh-python,
 libprotobuf-dev (>=3.0.0), libprotoc-dev (>=3.0.0), protobuf-compiler (>=3.0.0),
 python3-all-dev, python3-sip-dev
Standards-Version: 4.1.3
Section: libs
X-Python3-Version: >= 3.5
Homepage: https://github.com/Ultimaker/libArcus
Vcs-Browser: https://anonscm.debian.org/cgit/3dprinter/packages/libarcus.git/
Vcs-Git: https://anonscm.debian.org/git/3dprinter/packages/libarcus.git

Package: libarcus3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: message queue for Cura based on protobuf (shared library)
 This library contains C++ code and Python3 bindings for creating a socket
 in a thread and using this socket to send and receive messages based on
 the Protocol Buffers library. It is designed to facilitate the communication
 between Cura and its backend and similar code.
 This package contains the shared library.

Package: libarcus-dev
Section: libdevel
Architecture: any
Depends: libarcus3 (= ${binary:Version}), ${misc:Depends}
Description: message queue for Cura based on protobuf (development files)
 This library contains C++ code and Python3 bindings for creating a socket
 in a thread and using this socket to send and receive messages based on
 the Protocol Buffers library. It is designed to facilitate the communication
 between Cura and its backend and similar code.
 This package contains C++ headers and other development files.

Package: python3-arcus
Section: python
Architecture: any
Depends: libarcus3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Description: message queue for Cura based on protobuf (Python bindings)
 This library contains C++ code and Python3 bindings for creating a socket
 in a thread and using this socket to send and receive messages based on
 the Protocol Buffers library. It is designed to facilitate the communication
 between Cura and its backend and similar code.
 This package contains the Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake --with python3 --parallel

# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/libArcus-$1\.tar\.gz/ \
  https://github.com/Ultimaker/libArcus/tags .*/(\d\.\S+)\.tar\.gz

## libarcus 3.3.0

=== debian/changelog ===
libarcus (3.3.0-2) unstable; urgency=medium

  [ Gregor Riepl ]
  * Blacklisted incompatible python3-sip version (4.19.11+dfsg-1)
  * Added new symbols that appear with current build dependencies.
    Closes: #914953
  * Depend on python3-dev since we're not building for all Python
    interpreters.
    Closes: #913069

  [ Matthias Klose ]
  * Marked some symbols as optional not seen when building with -O3.
    Closes: #912412

  [ Petter Reinholdtsen ]
  * Corrected incorrectly blacklisting of python3-sip version 4.19.12+dfsg-1.

 -- Gregor Riepl <onitake@gmail.com>  Mon, 10 Dec 2018 11:46:52 +0000

libarcus (3.3.0-1) unstable; urgency=medium

  * New upstream release
  * Migrated to salsa

 -- Gregor Riepl <onitake@gmail.com>  Mon, 18 Jun 2018 19:00:38 +0200

libarcus (3.2.1-1) unstable; urgency=medium

  * New upstream release 3.2.1
  * Marked some more symbols as optional.
    They are not available when compiling with -O3 on ppcle.
    Thanks to Graham Inggs from the Ubuntu project.
  * Set Multi-Arch:same to enable co-installability

 -- Gregor Riepl <onitake@gmail.com>  Fri, 16 Mar 2018 08:52:19 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: libarcus
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
+Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
 Uploaders: Gregor Riepl <onitake@gmail.com>
-Build-Depends: debhelper (>= 10), cmake (>=2.8.12), dh-python,
+Build-Depends: debhelper (>=10.2.1), cmake (>=2.8.12), dh-python,
  libprotobuf-dev (>=3.0.0), libprotoc-dev (>=3.0.0), protobuf-compiler (>=3.0.0),
- python3-all-dev, python3-sip-dev
-Standards-Version: 4.1.3
+ python3-dev,
+ python3-sip-dev (>> 4.19.12+dfsg-1) | python3-sip-dev (<< 4.19.11+dfsg-1)
+Standards-Version: 4.1.4
 Section: libs
 X-Python3-Version: >= 3.5
 Homepage: https://github.com/Ultimaker/libArcus
-Vcs-Browser: https://anonscm.debian.org/cgit/3dprinter/packages/libarcus.git/
-Vcs-Git: https://anonscm.debian.org/git/3dprinter/packages/libarcus.git
+Vcs-Browser: https://salsa.debian.org/3dprinting-team/libarcus
+Vcs-Git: https://salsa.debian.org/3dprinting-team/libarcus.git
 
 Package: libarcus3
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: message queue for Cura based on protobuf (shared library)
  This library contains C++ code and Python3 bindings for creating a socket
@@ -26,6 +27,7 @@
 Package: libarcus-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libarcus3 (= ${binary:Version}), ${misc:Depends}
 Description: message queue for Cura based on protobuf (development files)
  This library contains C++ code and Python3 bindings for creating a socket
@@ -37,6 +39,7 @@
 Package: python3-arcus
 Section: python
 Architecture: any
+Multi-Arch: same
 Depends: libarcus3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
 Description: message queue for Cura based on protobuf (Python bindings)
  This library contains C++ code and Python3 bindings for creating a socket

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake --with python3

## libarcus 4.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,17 @@
 project(arcus)
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.6)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
+include(GenerateExportHeader)
 
 option(BUILD_PYTHON "Build " ON)
 option(BUILD_EXAMPLES "Build the example programs" ON)
 option(BUILD_STATIC "Build as a static library" OFF)
 
-option(MSVC_STATIC_RUNTIME "Link the MSVC runtime statically" OFF)
+if(WIN32)
+    option(MSVC_STATIC_RUNTIME "Link the MSVC runtime statically" OFF)
+endif()
 
 # We want to have access to protobuf_generate_cpp and other FindProtobuf features.
 # However, if ProtobufConfig is used instead, there is a CMake option that controls
@@ -19,25 +22,28 @@
 set(CMAKE_POSITION_INDEPENDENT_CODE ON) #Required if a patch to libArcus needs to be made via templates.
 
 if(BUILD_PYTHON)
-    set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
+    list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
+
+    # FIXME: Remove the code for CMake <3.12 once we have switched over completely.
+    # FindPython3 is a new module since CMake 3.12. It deprecates FindPythonInterp and FindPythonLibs.
+    if(${CMAKE_VERSION} VERSION_LESS 3.12)
+        # Use FindPythonInterp and FindPythonLibs for CMake <3.12
+        find_package(PythonInterp 3.4 REQUIRED)
+        find_package(PythonLibs 3.4 REQUIRED)
+    else()
+        # Use FindPython3 for CMake >=3.12
+        find_package(Python3 3.4 REQUIRED COMPONENTS Interpreter Development)
+    endif()
+
     find_package(SIP REQUIRED)
     if(NOT DEFINED LIB_SUFFIX)
         set(LIB_SUFFIX "")
     endif()
-    if(EXISTS /etc/debian_version)
-        # Running on a debian-based system, which requires special handling for python modules.
-        set(PYTHON_SITE_PACKAGES_DIR lib${LIB_SUFFIX}/python3/dist-packages CACHE STRING "Directory to install Python bindings to")
-    else()
-        set(PYTHON_SITE_PACKAGES_DIR lib${LIB_SUFFIX}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages CACHE STRING "Directory to install Python bindings to")
-    endif()
-    include_directories(python/ src/ ${SIP_INCLUDE_DIR} ${PYTHON_INCLUDE_DIR})
+
+    include_directories(python/ src/ ${SIP_INCLUDE_DIRS} ${Python3_INCLUDE_DIRS})
 endif()
 
-if(NOT ${CMAKE_VERSION} VERSION_LESS 3.1)
-    set(CMAKE_CXX_STANDARD 11)
-else()
-    set(CMAKE_CXX_FLAGS "-std=c++11")
-endif()
+set(CMAKE_CXX_STANDARD 11)
 
 if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
@@ -55,15 +61,15 @@
     src/Socket.h
     src/SocketListener.h
     src/Types.h
-    src/ArcusExport.h
     src/MessageTypeStore.h
     src/Error.h
+    ${CMAKE_CURRENT_BINARY_DIR}/src/ArcusExport.h
 )
 
 set(ARCUS_VERSION 1.1.0)
 set(ARCUS_SOVERSION 3)
 
-set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
 
 if(BUILD_STATIC)
     add_library(Arcus STATIC ${arcus_SRCS})
@@ -116,7 +122,16 @@
     SOVERSION ${ARCUS_SOVERSION}
     PUBLIC_HEADER "${arcus_HDRS}"
     DEFINE_SYMBOL MAKE_ARCUS_LIB
+    CXX_VISIBILITY_PRESET hidden
+    VISIBILITY_INLINES_HIDDEN 1
 )
+
+generate_export_header(Arcus
+    EXPORT_FILE_NAME src/ArcusExport.h
+)
+# This is required when building out-of-tree.
+# The compiler won't find the generated header otherwise.
+include_directories(${CMAKE_BINARY_DIR}/src)
 
 if(BUILD_EXAMPLES)
     add_subdirectory(examples)

=== debian/changelog ===
libarcus (4.4.1-2build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:20 +0100

libarcus (4.4.1-2) unstable; urgency=medium

  * Team upload.
  * Ignore symbol changes for now.

 -- Christoph Berg <myon@debian.org>  Tue, 28 Jan 2020 21:59:23 +0100

libarcus (4.4.1-1) unstable; urgency=medium

  * Team upload.

  [ Gregor Riepl ]
  * New upstream version 4.2.0
  * Updated standards
  * Enable multi-Python build
  * Removed explicit Python 3.5 dependency, bullseye no longer needs it
  * Cleaned up exported API, patches are already merged upstream

  [ Christoph Berg ]
  * New upstream version 4.4.1.
  * tests: Depend on all python3 versions.

  [ Nicolas Dandrimont ]
  * Add patch to force python version in CMake.

 -- Christoph Berg <myon@debian.org>  Tue, 28 Jan 2020 10:39:42 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,12 @@
 Priority: optional
 Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
 Uploaders: Gregor Riepl <onitake@gmail.com>
-Build-Depends: debhelper (>=10.2.1), cmake (>=2.8.12), dh-python,
+Build-Depends: debhelper (>=10.2.1), cmake (>=3.12), dh-python,
  libprotobuf-dev (>=3.0.0), libprotoc-dev (>=3.0.0), protobuf-compiler (>=3.0.0),
- python3-dev,
+ python3-all-dev,
  python3-sip-dev (>> 4.19.12+dfsg-1) | python3-sip-dev (<< 4.19.11+dfsg-1)
-Standards-Version: 4.1.4
+Standards-Version: 4.4.0
 Section: libs
-X-Python3-Version: >= 3.5
 Homepage: https://github.com/Ultimaker/libArcus
 Vcs-Browser: https://salsa.debian.org/3dprinting-team/libarcus
 Vcs-Git: https://salsa.debian.org/3dprinting-team/libarcus.git
@@ -40,7 +39,8 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: libarcus3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
+Depends: libarcus3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
+ ${python3:Depends}, ${sip3:Depends}
 Description: message queue for Cura based on protobuf (Python bindings)
  This library contains C++ code and Python3 bindings for creating a socket
  in a thread and using this socket to send and receive messages based on

=== debian/rules ===
--- 
+++ 
@@ -4,5 +4,10 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
+export PYBUILD_CONFIGURE_ARGS=-DPYVER={version}
+
+# Symbols vary across architectures, leave fix for later
+export DPKG_GENSYMBOLS_CHECK_LEVEL = 0
+
 %:
-	dh $@ --buildsystem=cmake --with python3
+	dh $@ --buildsystem=pybuild --with python3 --with sip3

=== debian/tests/control ===
Test-Command: for py in $(py3versions -r 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import Arcus; print(Arcus)" ; done
Depends: @, python3-all

## libarcus 4.6.2

=== debian/changelog ===
libarcus (4.6.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.
  * Drop symbols file, maintaining it was much more effort than it gained us.

 -- Christoph Berg <myon@debian.org>  Tue, 18 Aug 2020 21:53:50 +0200

libarcus (4.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Fri, 13 Mar 2020 18:19:25 +0100

## libarcus 4.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # We want to have access to protobuf_generate_cpp and other FindProtobuf features.
 # However, if ProtobufConfig is used instead, there is a CMake option that controls
 # this, which defaults to OFF. We need to force this option to ON instead.
-set(protobuf_MODULE_COMPATIBLE ON CACHE "" INTERNAL FORCE)
+set(protobuf_MODULE_COMPATIBLE ON CACHE INTERNAL "" FORCE)
 find_package(Protobuf 3.0.0 REQUIRED)
 
 set(CMAKE_POSITION_INDEPENDENT_CODE ON) #Required if a patch to libArcus needs to be made via templates.
@@ -24,16 +24,10 @@
 if(BUILD_PYTHON)
     list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
 
-    # FIXME: Remove the code for CMake <3.12 once we have switched over completely.
-    # FindPython3 is a new module since CMake 3.12. It deprecates FindPythonInterp and FindPythonLibs.
-    if(${CMAKE_VERSION} VERSION_LESS 3.12)
-        # Use FindPythonInterp and FindPythonLibs for CMake <3.12
-        find_package(PythonInterp 3.4 REQUIRED)
-        find_package(PythonLibs 3.4 REQUIRED)
-    else()
-        # Use FindPython3 for CMake >=3.12
-        find_package(Python3 3.4 REQUIRED COMPONENTS Interpreter Development)
-    endif()
+    # FIXME: Use FindPython3 to find Python, new in CMake 3.12.
+    # However currently on our CI server it finds the wrong Python version and then doesn't find the headers.
+    find_package(PythonInterp 3.4 REQUIRED)
+    find_package(PythonLibs 3.4 REQUIRED)
 
     find_package(SIP REQUIRED)
     if(NOT DEFINED LIB_SUFFIX)

=== debian/changelog ===
libarcus (4.8-1) unstable; urgency=medium

  * New upstream version.
  * Set python lib directories correctly.
  * Mark autopkgtest as superficial. (Closes: #974450)
  * debian/watch: Handle -beta releases.
  * Add myself to Uploaders.

 -- Christoph Berg <myon@debian.org>  Mon, 16 Nov 2020 10:38:45 +0100

libarcus (4.7.1-2) unstable; urgency=medium

  * Team upload.
  * Make reverse-dependencies require our current version as minimum
    dependency via shlibs. (Closes: #972422)

 -- Christoph Berg <myon@debian.org>  Sat, 31 Oct 2020 23:38:21 +0100

libarcus (4.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 4.7.1.

 -- Christoph Berg <myon@debian.org>  Sun, 06 Sep 2020 23:26:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libarcus
 Priority: optional
 Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
-Uploaders: Gregor Riepl <onitake@gmail.com>
+Uploaders: Gregor Riepl <onitake@gmail.com>,
+ Christoph Berg <myon@debian.org>,
 Build-Depends: debhelper (>=10.2.1), cmake (>=3.12), dh-python,
  libprotobuf-dev (>=3.0.0), libprotoc-dev (>=3.0.0), protobuf-compiler (>=3.0.0),
  python3-all-dev,

=== debian/tests/control ===
Test-Command: for py in $(py3versions -r 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import Arcus; print(Arcus)" ; done
Depends: @, python3-all
Restrictions: superficial

## libarcus 4.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(arcus)
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.8)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
@@ -24,10 +24,18 @@
 if(BUILD_PYTHON)
     list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
 
-    # FIXME: Use FindPython3 to find Python, new in CMake 3.12.
-    # However currently on our CI server it finds the wrong Python version and then doesn't find the headers.
-    find_package(PythonInterp 3.4 REQUIRED)
-    find_package(PythonLibs 3.4 REQUIRED)
+    # FIXME: Remove the code for CMake <3.12 once we have switched over completely.
+    # FindPython3 is a new module since CMake 3.12. It deprecates FindPythonInterp and FindPythonLibs.
+    if(${CMAKE_VERSION} VERSION_LESS 3.12)
+        # FIXME: Use FindPython3 to find Python, new in CMake 3.12.
+        # However currently on our CI server it finds the wrong Python version and then doesn't find the headers.
+        find_package(PythonInterp 3.4 REQUIRED)
+        find_package(PythonLibs 3.4 REQUIRED)
+
+    else()
+        # Use FindPython3 for CMake >=3.12
+        find_package(Python3 3.4 REQUIRED COMPONENTS Interpreter Development)
+    endif()
 
     find_package(SIP REQUIRED)
     if(NOT DEFINED LIB_SUFFIX)
@@ -37,7 +45,7 @@
     include_directories(python/ src/ ${SIP_INCLUDE_DIRS} ${Python3_INCLUDE_DIRS})
 endif()
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 
 if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
@@ -88,7 +96,7 @@
 if(BUILD_PYTHON)
     set(SIP_EXTRA_FILES_DEPEND python/SocketListener.sip python/Types.sip python/PythonMessage.sip python/Error.sip)
     set(SIP_EXTRA_SOURCE_FILES python/PythonMessage.cpp)
-    set(SIP_EXTRA_OPTIONS -g) # -g means always release the GIL before calling C++ methods.
+    set(SIP_EXTRA_OPTIONS -g -n PyQt5.sip) # -g means always release the GIL before calling C++ methods. -n PyQt5.sip is required to not get the PyCapsule error
     add_sip_python_module(Arcus python/Socket.sip Arcus)
 endif()

=== examples/CMakeLists.txt ===

include_directories(example ${CMAKE_CURRENT_BINARY_DIR})

set(example_SRCS
    example.cpp
    example_pb2.py
)

protobuf_generate_cpp(example_PB_SRCS example_PB_HDRS "example.proto")

add_executable(example ${example_SRCS} ${example_PB_SRCS})
target_link_libraries(example Arcus)
if(NOT WIN32 OR CMAKE_COMPILER_IS_GNUCXX)
    target_link_libraries(example pthread)
    set_target_properties(example PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()

add_custom_command(
    OUTPUT example_pb2.py
    COMMAND  ${PROTOBUF_PROTOC_EXECUTABLE}
    ARGS --python_out ${CMAKE_CURRENT_BINARY_DIR} --proto_path=${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/example.proto
    COMMENT "Running Python protocol buffer compiler on example.proto"
    VERBATIM )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/example_py.sh ${CMAKE_CURRENT_BINARY_DIR}/example_py.sh)

=== debian/changelog ===
libarcus (4.13.0-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Mar 2022 18:50:44 +0100

libarcus (4.13.0-2) unstable; urgency=medium

  * Depend on python3-pyqt5.

 -- Christoph Berg <myon@debian.org>  Fri, 14 Jan 2022 09:58:26 +0100

libarcus (4.13.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake, libprotobuf-dev,
      libprotoc-dev, protobuf-compiler and python3-sip-dev.

  [ Christoph Berg ]
  * New upstream version 4.13.0.

 -- Christoph Berg <myon@debian.org>  Fri, 14 Jan 2022 09:24:21 +0100

=== debian/control ===
Source: libarcus
Priority: optional
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders:
 Gregor Riepl <onitake@gmail.com>,
 Christoph Berg <myon@debian.org>,
Build-Depends:
 cmake,
 debhelper (>= 10.2.1),
 dh-python,
 libprotobuf-dev,
 libprotoc-dev,
 protobuf-compiler,
 python3-all-dev,
 python3-sip-dev,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/Ultimaker/libArcus
Vcs-Browser: https://salsa.debian.org/3dprinting-team/libarcus
Vcs-Git: https://salsa.debian.org/3dprinting-team/libarcus.git

Package: libarcus3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: message queue for Cura based on protobuf (shared library)
 This library contains C++ code and Python3 bindings for creating a socket
 in a thread and using this socket to send and receive messages based on
 the Protocol Buffers library. It is designed to facilitate the communication
 between Cura and its backend and similar code.
 This package contains the shared library.

Package: libarcus-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libarcus3 (= ${binary:Version}),
 ${misc:Depends},
Description: message queue for Cura based on protobuf (development files)
 This library contains C++ code and Python3 bindings for creating a socket
 in a thread and using this socket to send and receive messages based on
 the Protocol Buffers library. It is designed to facilitate the communication
 between Cura and its backend and similar code.
 This package contains C++ headers and other development files.

Package: python3-arcus
Section: python
Architecture: any
Multi-Arch: same
Depends:
 libarcus3 (= ${binary:Version}),
 python3-pyqt5,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 ${sip3:Depends},
Description: message queue for Cura based on protobuf (Python bindings)
 This library contains C++ code and Python3 bindings for creating a socket
 in a thread and using this socket to send and receive messages based on
 the Protocol Buffers library. It is designed to facilitate the communication
 between Cura and its backend and similar code.
 This package contains the Python 3 bindings.

=== debian/tests/control ===
Test-Command: for py in $(py3versions -r 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import Arcus; print(Arcus)" ; done
Depends:
 python3-all,
 @,
Restrictions: superficial

## libarcus 5.0.0

=== CMakeLists.txt ===
project(arcus)
cmake_minimum_required(VERSION 3.20)
include(cmake/StandardProjectSettings.cmake)

include(CMakePackageConfigHelpers)
include(GenerateExportHeader)

option(BUILD_PYTHON "Build Python bindings for this library" ON)

find_package(Protobuf 3.17.1 REQUIRED)

set(arcus_SRCS
    src/Socket.cpp
    src/SocketListener.cpp
    src/MessageTypeStore.cpp
    src/PlatformSocket.cpp
    src/Error.cpp
)

set(arcus_HDRS
    src/Socket.h
    src/SocketListener.h
    src/Types.h
    src/MessageTypeStore.h
    src/Error.h
    ${CMAKE_CURRENT_BINARY_DIR}/src/ArcusExport.h
)

set(ARCUS_VERSION 5.0.0)
set(ARCUS_SOVERSION 5)

if(BUILD_SHARED_LIBS)
    add_library(Arcus SHARED ${arcus_SRCS})
else()
    add_library(Arcus STATIC ${arcus_SRCS})
endif()
set_project_standards(Arcus)
use_threads(Arcus)
set_rpath(TARGETS
            Arcus
          PATHS
            "$<$<PLATFORM_ID:Linux>:usr/bin>"
            "$<$<PLATFORM_ID:Linux>:usr/bin/lib>"
            "$<$<PLATFORM_ID:Darwin>:../lib>"
          RELATIVE)

target_include_directories(Arcus PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${PROTOBUF_INCLUDE_DIR}
)
target_link_libraries(Arcus PUBLIC protobuf::libprotobuf)

if(WIN32)
    target_compile_definitions(Arcus PRIVATE -D_WIN32_WINNT=0x0600)
    # Declare we require Vista or higher, this allows us to use IPv6 functions.

    target_link_libraries(Arcus PUBLIC Ws2_32)
endif()

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug" OR ${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo")
    target_compile_definitions(Arcus PRIVATE -DARCUS_DEBUG)
endif()

set_target_properties(Arcus PROPERTIES
    FRAMEWORK FALSE
    VERSION ${ARCUS_VERSION}
    SOVERSION ${ARCUS_SOVERSION}
    PUBLIC_HEADER "${arcus_HDRS}"
    DEFINE_SYMBOL MAKE_ARCUS_LIB
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1
)

generate_export_header(Arcus
    EXPORT_FILE_NAME src/ArcusExport.h
)
# This is required when building out-of-tree.
# The compiler won't find the generated header otherwise.
include_directories(${CMAKE_BINARY_DIR}/src)

install(TARGETS Arcus
    EXPORT Arcus-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Arcus
)

install(EXPORT Arcus-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Arcus
)

configure_package_config_file(ArcusConfig.cmake.in ${CMAKE_BINARY_DIR}/ArcusConfig.cmake INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Arcus)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/ArcusConfigVersion.cmake VERSION ${ARCUS_VERSION} COMPATIBILITY SameMajorVersion)

install(FILES
    ${CMAKE_BINARY_DIR}/ArcusConfig.cmake
    ${CMAKE_BINARY_DIR}/ArcusConfigVersion.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Arcus
)

# Create the Python bindings
if(BUILD_PYTHON)
    list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

    if(NOT DEFINED Python_VERSION)
        set(Python_VERSION
                3.10
                CACHE STRING "Python Version" FORCE)
        message(STATUS "Setting Python version to ${Python_VERSION}. Set Python_VERSION if you want to compile against an other version.")
    endif()
    if(APPLE)
        set(Python_FIND_FRAMEWORK NEVER)
    endif()
    find_package(cpython ${Python_VERSION} QUIET COMPONENTS Interpreter Development)
    if(NOT TARGET cpython::cpython)
        find_package(Python ${Python_VERSION} EXACT REQUIRED COMPONENTS Interpreter Development)
    else()
        add_library(Python::Python ALIAS cpython::python)
        set(Python_SITEARCH "${CMAKE_INSTALL_PREFIX}/lib/python${Python_VERSION}/site-packages")
        set(Python_EXECUTABLE ${cpython_PACKAGE_FOLDER_RELEASE}/bin/python3)
        set(ENV{PYTHONPATH} ${Python_SITEARCH})
    endif()
    message(STATUS "Linking and building ${project_name} against Python ${Python_VERSION}")

    find_package(SIP REQUIRED 6.5.0)

    add_library(pyArcus INTERFACE ${CMAKE_SOURCE_DIR}/python/PythonMessage.cpp)
    set_project_standards(pyArcus)
    set_rpath(TARGETS
                pyArcus
              PATHS
                "$<$<PLATFORM_ID:Linux>:usr/bin>"
                "$<$<PLATFORM_ID:Linux>:usr/bin/lib>"
                "$<$<PLATFORM_ID:Darwin>:../lib>"
                "$<$<PLATFORM_ID:Darwin>:../Resources/lib/>"
                "../../"
              RELATIVE)
    use_threads(pyArcus)

    target_include_directories(pyArcus
            INTERFACE
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
            $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/python/>
            )

    target_link_libraries(pyArcus INTERFACE Arcus protobuf::libprotobuf Python::Python)

    add_sip_module(pyArcus)
    if (DEFINED Python_SITELIB_LOCAL)
        install_sip_module(pyArcus ${Python_SITELIB_LOCAL})
    else()
        install_sip_module(pyArcus)
    endif ()
endif()

=== test_package/CMakeLists.txt ===
project(PackageTest)
cmake_minimum_required(VERSION 3.20)

include(../cmake/StandardProjectSettings.cmake)

find_package(Arcus REQUIRED)

add_executable(test test.cpp)
set_project_standards(test)
set_project_warnings(test)
use_threads(test)

target_link_libraries(test
        PUBLIC
        Arcus
        )

=== debian/changelog ===
libarcus (5.0.0-6) unstable; urgency=medium

  * Add cstdint include to address build failure with g++ 15.
    Closes: #1097162

 -- Gregor Riepl <onitake@gmail.com>  Mon, 01 Sep 2025 21:55:21 +0200

libarcus (5.0.0-5) unstable; urgency=medium

  * Remove dependency on SIP 4.x, it's no longer needed

 -- Gregor Riepl <onitake@gmail.com>  Thu, 11 Jan 2024 11:42:14 +0100

libarcus (5.0.0-4) unstable; urgency=medium

  * debian/tests: Python module got renamed to pyArcus.

 -- Christoph Berg <myon@debian.org>  Wed, 05 Jul 2023 14:28:53 +0000

libarcus (5.0.0-3) unstable; urgency=medium

  * Upload to unstable.

 -- Christoph Berg <myon@debian.org>  Sun, 02 Jul 2023 21:27:57 +0200

libarcus (5.0.0-2) experimental; urgency=medium

  [ Gregor Riepl ]
  * Add patch to fix protobuf bug. Thanks Laszlo! Closes: #1012575, #1023497

 -- Christoph Berg <myon@debian.org>  Sat, 31 Dec 2022 13:18:42 +0200

libarcus (5.0.0-1) experimental; urgency=medium

  [ Sebastian Kuzminsky ]
  * New upstream version 5.0.0.
  * Refresh patches.
  * Build-depend on the sip6 tools.
  * pq: reduce protobuf requirement to 3.12.4
  * Depend on python3-pyqt6.

  [ Christoph Berg ]
  * Bump libarcus soname to 5.
  * Use DH 13; remove now-redundant shlibs mangling from debian/rules.

 -- Christoph Berg <myon@debian.org>  Fri, 27 May 2022 15:56:48 +0200

=== debian/control ===
--- 
+++ 
@@ -6,20 +6,21 @@
  Christoph Berg <myon@debian.org>,
 Build-Depends:
  cmake,
- debhelper (>= 10.2.1),
+ debhelper-compat (= 13),
  dh-python,
  libprotobuf-dev,
  libprotoc-dev,
  protobuf-compiler,
  python3-all-dev,
- python3-sip-dev,
+ python3-sipbuild,
+ sip-tools,
 Standards-Version: 4.6.0
 Section: libs
 Homepage: https://github.com/Ultimaker/libArcus
 Vcs-Browser: https://salsa.debian.org/3dprinting-team/libarcus
 Vcs-Git: https://salsa.debian.org/3dprinting-team/libarcus.git
 
-Package: libarcus3
+Package: libarcus5
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -37,7 +38,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libarcus3 (= ${binary:Version}),
+ libarcus5 (= ${binary:Version}),
  ${misc:Depends},
 Description: message queue for Cura based on protobuf (development files)
  This library contains C++ code and Python3 bindings for creating a socket
@@ -51,12 +52,11 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libarcus3 (= ${binary:Version}),
- python3-pyqt5,
+ libarcus5 (= ${binary:Version}),
+ python3-pyqt6,
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
- ${sip3:Depends},
 Description: message queue for Cura based on protobuf (Python bindings)
  This library contains C++ code and Python3 bindings for creating a socket
  in a thread and using this socket to send and receive messages based on

=== debian/tests/control ===
Test-Command: for py in $(py3versions -r 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import pyArcus; print(pyArcus)" ; done
Depends:
 python3-all,
 @,
Restrictions: superficial
